;dict.inc - the dictionary

;Overall dictionary (list of vocabularies/wordlists)
dict
        dc      root_wordlist
        dc      0,0,0,0,0,0,0,0
comp_wordlist   dc      root_wordlist   ;Compilation wordlist
num_wordlists   dc      1
max_wordlists   dc      9

;ROOT vocabulary
; Miscellaneous CORE words
entry fetch, "@", FETCH, 0, 0
entry store, "!", STORE, 0, fetch
entry c_fetch, "C@", C_FETCH, 0, store
entry c_store, "C!", C_STORE, 0, c_fetch
entry here, "HERE", HERE, 0, c_store
entry _cmove, "CMOVE", _CMOVE, 0, here
entry key, "KEY", KEY, 0, _cmove
entry accept, "ACCEPT", ACCEPT, 0, key
entry parse, "PARSE", PARSE, 0, accept
entry allot, "ALLOT", ALLOT, 0, parse
entry char_plus, "CHAR+", CHAR_PLUS, 0, allot
entry cell_plus, "CELL+", CELL_PLUS, 0, char_plus
entry bye, "BYE", BYE, 0, cell_plus
entry new_word, "NEW-WORD", NEW_WORD, 0, bye
entry start_compile, ":", START_COMPILE, 0, new_word
entry end_compile, ";", END_COMPILE, f_immed | f_componly, start_compile
entry immediate, "IMMEDIATE", IMMEDIATE, 0, end_compile
entry postpone, "POSTPONE", POSTPONE, f_immed | f_componly, immediate
entry comma, ",", COMMA, 0, postpone
entry c_comma, "C,", C_COMMA, 0, comma
entry literal, "LITERAL", LITERAL, f_immed | f_componly, c_comma
entry constant, "CONSTANT", CONSTANT, 0, literal
entry variable, "VARIABLE", VARIABLE, 0, constant
entry create, "CREATE", CREATE, 0, variable
entry does, "DOES>", DOES, 0, create

; Facility (in misc.asm for now)
entry at_xy, "AT-XY", AT_XY, 0, does
entry page, "PAGE", PAGE, 0, at_xy

; Graphics (graphics.asm)
;entry graphmode, "GRAPHMODE", GRAPHMODE, 0, page
;entry textmode, "TEXTMODE", TEXTMODE, 0, graphmode
;entry hline, "HLINE", HLINE, 0, textmode
;entry vline, "VLINE", VLINE, 0, hline
;entry line, "LINE", LINE, 0, vline
;entry putpixel, "PUTPIXEL", PUTPIXEL, 0, line
;entry circle, "CIRCLE", CIRCLE, 0, putpixel

; Text manipulation (text.asm)
entry type, "TYPE", TYPE, 0, page ;circle
entry emit, "EMIT", EMIT, 0, type
entry cr, "CR", CR, 0, emit
entry space, "SPACE", SPACE, 0, cr
entry base, "BASE", BASE, 0, space
entry print, ".", PRINT, 0, base
entry print_string, '."', PRINT_STRING, f_immed | f_componly, print
entry s_quote, 'S"', S_QUOTE, f_immed | f_componly, print_string
entry pad, "PAD", PAD, 0, s_quote

; BLOCK words (block.asm)   Fully implemented!
;entry blk, "BLK", BLK, 0, pad
;entry block, "BLOCK", BLOCK, 0, blk
;entry buffer, "BUFFER", BUFFER, 0, block
;entry flush, "FLUSH", FLUSH, 0, buffer
;entry load, "LOAD", LOAD, 0, flush
;entry save_buffers, "SAVE-BUFFERS", SAVE_BUFFERS, 0, load
;entry update, "UPDATE", UPDATE, 0, save_buffers
; BLOCK-ext words
;entry empty_buffers, "EMPTY-BUFFERS", EMPTY_BUFFERS, 0, update
;entry list, "LIST", LIST, 0, empty_buffers

; Debugging words
entry stack_trace, ".S", STACK_TRACE, 0, pad ;list

; Math (math.asm)
entry plus, "+", PLUS, 0, stack_trace
entry minus, "-", MINUS, 0, plus
entry _1plus, "1+", _1PLUS, 0, minus
entry _1minus, "1-", _1MINUS, 0, _1plus
entry _2mul, "2*", _2MUL, 0, _1minus
entry _2div, "2/", _2DIV, 0, _2mul
entry multiply, "*", MULTIPLY, 0, _2div
entry m_multiply, "M*", M_MULTIPLY, 0, multiply
entry divide, "/", DIVIDE, 0, m_multiply
entry mod, "MOD", MOD, 0, divide
entry div_mod, "/MOD", DIV_MOD, 0, mod
entry mul_div, "*/", MUL_DIV, 0, div_mod
entry mul_div_mod, "*/MOD", MUL_DIV_MOD, 0, mul_div
entry abs, "ABS", ABS, 0, mul_div_mod
entry negate, "NEGATE", NEGATE, 0, abs

; Logic (logic.asm)
entry invert, "INVERT", INVERT, 0, negate
entry _and, "AND", _AND, 0, invert
entry _or, "OR", _OR, 0, _and
entry _xor, "XOR", _XOR, 0, _or
entry lshift, "LSHIFT", LSHIFT, 0, _xor
entry rshift, "RSHIFT", RSHIFT, 0, lshift

; Conditionals (cond.asm)
entry _0equals, "0=", _0EQUALS, 0, rshift
entry _0not_equals, "0<>", _0NOT_EQUALS, 0, _0equals
entry _0lt, "0<", _0LT, 0, _0not_equals
entry _0gt, "0>", _0GT, 0, _0lt
entry equals, "=", EQUALS, 0, _0gt
entry not_equals, "<>", NOT_EQUALS, 0, equals
entry lt, "<", LT, 0, not_equals
entry gt, ">", GT, 0, lt
entry lte, "<=", LTE, 0, gt
entry gte, ">=", GTE, 0, lte

; Stack manipulation (stack.asm)
entry dup, "DUP", DUP, 0, gte
entry qdup, "?DUP", QDUP, 0, dup
entry _2dup, "2DUP", _2DUP, 0, qdup
entry drop, "DROP", DROP, 0, _2dup
entry swap, "SWAP", SWAP, 0, drop
entry over, "OVER", OVER, 0, swap
entry to_r, ">R", TO_R, f_immed | f_componly, over
entry r_from, "R>", R_FROM, f_immed | f_componly, to_r
entry r_fetch, "R@", R_FETCH, f_immed | f_componly, r_from
entry rot, "ROT", ROT, 0, r_fetch
entry depth, "DEPTH", DEPTH, 0, rot

; Control Flow (flow.asm)
entry if, "IF", IF, f_immed, depth
entry else, "ELSE", ELSE, f_immed, if
entry then, "THEN", THEN, f_immed, else
entry case, "CASE", CASE, f_immed, then
entry endcase, "ENDCASE", ENDCASE, f_immed, case
entry of, "OF", OF, f_immed, endcase
entry endof, "ENDOF", ENDOF, f_immed, of
entry begin, "BEGIN", BEGIN, f_immed | f_componly, endof
entry until, "UNTIL", UNTIL, f_immed | f_componly, begin
entry again, "AGAIN", AGAIN, f_immed | f_componly, until
entry _do, "DO", _DO, f_immed | f_componly, again
entry _loop, "LOOP", _LOOP, f_immed | f_componly, _do

root_wordlist   dc      _loop


;ASSEMBLER vocabulary


