; flow.asm - Control Flow routines

AHEAD   ; ( C: -- orig )
        call    HERE
        ret
end AHEAD



IF      ; ( C: -- orig , push location of jump address )
;Run time: ( x -- , skip the following statements if x=0 )
        upsh    cell .code
        call    HERE
        upsh    cell .end-.code
        call    DUP
        call    ALLOT
        call    _CMOVE

        call    HERE
        upsh    cell CELLSIZE
        call    MINUS
        ret
.code
        sub     ebp, CELLSIZE
        cmp     [ebp], cell 0
        jz near 0
.end
end IF



ELSE    ; ( C: orig1 -- orig2 )
        upsh    cell .code              ;Resolve orig1
        call    HERE
        upsh    cell .end-.code
        call    DUP
        call    ALLOT
        call    _CMOVE

        call    HERE                    ;Copy code: JMP <forward ref>
        call    OVER
        call    CELL_PLUS
        call    MINUS
        call    SWAP
        call    STORE

        call    HERE                    ;New forward reference: orig2
        upsh    cell CELLSIZE
        call    MINUS
        ret
.code
        jmp     0
.end
end ELSE



THEN    ; ( C: orig -- , Resolve forward reference )
        call    HERE
        call    OVER
        call    CELL_PLUS
        call    MINUS
        call    SWAP
        call    STORE
        ret
end THEN



CASE            ; ( C: -- case-sys )
end CASE



ENDCASE         ; ( C: case-sys -- )
end ENDCASE



OF              ; ( C: -- of-sys )
;Run time: ( x1 x2 --   | x1 )
        upsh    cell .code
        call    HERE
        upsh    cell .end-.code
        call    DUP
        call    ALLOT
        call    _CMOVE

        call    HERE
        upsh    cell CELLSIZE + 1+CELLSIZE
        call    MINUS
        ret
.code           ; (OF)
        push    eax
        upop    eax
        cmp     eax, tosreg
        pop     eax
        jne near 0               ;Forward reference
        call    DROP
.end
end OF



ENDOF           ; ( C: case-sys1 of-sys -- case-sys2 )
        call    THEN
        ret
end ENDOF



BEGIN   ; ( C: -- dest )
        call    HERE
        ret
end BEGIN



UNTIL   ; ( C: dest -- , Resolve the reference to dest )
;Run time: ( x -- , Loop back to dest if x=0 )
        ;SUB BP, 2
        upsh    cell 0x83       ; SUB sign-extend byte
        call    C_COMMA
        upsh    cell 0xED
        call    C_COMMA
        upsh    cell 0x02       ; imm: 2
        call    C_COMMA

        ;CMP SS:[BP], 0
        upsh    cell 0x83       ; CMP sign-extend byte
        call    C_COMMA
        upsh    cell 0x7E       ; mod r/m: SS:[BP+d8]
        call    C_COMMA
        upsh    cell 0x00       ; d8: 0
        call    C_COMMA
        upsh    cell 0x00
        call    C_COMMA

        ;JZ dest (w/ full displacement)
        upsh    cell 0x0F
        call    C_COMMA
        upsh    cell 0x84
        call    C_COMMA
        ;stack: ( dest )
        call    HERE            ; Create relative address
        call    CELL_PLUS
        call    MINUS
        call    COMMA

        ret
end UNTIL



AGAIN   ; ( C: dest -- , Unconditional loop )
        ;JMP (w/ full displacement)
        upsh    cell 0xE9
        call    C_COMMA
        ;stack: ( dest )
        call    HERE            ; Create relative address
        call    CELL_PLUS
        call    MINUS
        call    COMMA

        ret
end AGAIN



_DO     ; DO ( C: -- do-sys )
;Run time:   ( n1 n2 -- ) ( R: -- loop-sys )
        ret
end _DO



_LOOP   ; LOOP ( C: do-sys -- )
;Run time:     ( -- ) ( R: loop-sys1 --  | loop-sys2 )
        ret
end _LOOP



