/* adjustboot.c

Sets the "number of sectors to load" field in a boot image, which needs to
be done after modules are appended to it.

Copyright (C) 1999 Thomas Novelli
	Retro is distributed under the terms of the GNU LGPL, version 2 or
	greater. (For the text of the license, see the file COPYING.LIB)


 */


#include <stdio.h>


int main (int argc, char **argv)
{
  FILE *bootf;
  int size;	// Size of bootloader file
  unsigned char sectors;

  if (argc != 2) {
    printf("Usage: %s <disk image>\n", argv[0]);
    exit(1);
  }
  
  if (!(bootf = fopen(argv[1], "rb+"))) {
    printf("Error opening %s\n", argv[1]);
    exit(2);
  }

  // Count the size of bootloader
  for (size=0; !feof(bootf); size++)
    fgetc(bootf);
  rewind(bootf);
  size--;
  sectors = (size - size%512) >> 9;
  printf("%d bytes in %d sectors\n", size, sectors);

  // Write size field
  fseek(bootf, 3, SEEK_SET);
  fputc(sectors, bootf);

  fclose(bootf);
  
  return 0;
}
